﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;
using Forum.Model;

namespace Forum.ViewModel
{
    public class ThreadPostViewModel : ViewModelBase
    {

        private ThreadPost threadPost;

        public ThreadPostViewModel(ThreadPost threadPost)
        {
            this.threadPost = threadPost;

            foreach (Post p in threadPost.Posts)
                this.Posts.Add(new PostViewModel(p));
        }

        private PostViewModelCollection _posts;

        public PostViewModelCollection Posts
        {
            get
            {
                if (_posts == null)
                    _posts = new PostViewModelCollection();

                return _posts;
            }
        }

        public PostViewModel FirstPost
        {
            get { return this.Posts.First(); }
        }

        public bool IsRead
        {
            get { return this.threadPost.IsRead; }
            set
            {
                if (value != this.threadPost.IsRead)
                {
                    this.threadPost.IsRead = value;
                    OnPropertyChanged("IsRead");
                }
            }
        }
    }

    public class ThreadPostViewModelCollection : ObservableCollection<ThreadPostViewModel>
    { }
}
